OGRE: Ogre::GLSLMonolithicProgram Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | Public Attributes | List of all members
Ogre::GLSLMonolithicProgram Class Reference

Model of OpenGL program object created using the glLinkProgram method of linking. More...

`#include <OgreGLSLMonolithicProgram.h>`

Inheritance diagram for Ogre::GLSLMonolithicProgram:
[legend]

## Public Member Functions
| GLSLMonolithicProgram (GLSLShader *vertexProgram, GLSLShader *hullProgram, GLSLShader *domainProgram, GLSLShader *geometryProgram, GLSLShader *fragmentProgram, GLSLShader *computeProgram)
| Constructor should only be used by GLSLMonolithicProgramManager. More...
| ~GLSLMonolithicProgram (void)
void | activate (void)
| Makes a program object active by making sure it is linked and then putting it in use. More...
virtual void | extractLayoutQualifiers (void)
| Finds layout qualifiers in the shader source and sets attribute indices appropriately. More...
virtual GLint | getAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the index of a non-standard attribute bound in the linked code. More...
GLSLShader * | getComputeShader () const
GLSLShader * | getDomainShader () const
GLSLShader * | getFragmentShader () const
GLSLShader * | getGeometryShader () const
GLuint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLSLShader * | getHullShader () const
GL3PlusOldVertexArrayObject * | getVertexArrayObject ()
GLSLShader * | getVertexShader () const
bool | isAttributeValid (VertexElementSemantic semantic, uint index)
| Is a non-standard attribute bound in the linked code? More...
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)
| Updates program object uniforms using data from pass iteration GpuProgramParameters. More...
void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniform blocks using data from GpuProgramParameters. More...
void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniforms using data from GpuProgramParameters. More...

## Public Attributes
GLint | mBaseInstanceLocation

## Detailed Description

Model of OpenGL program object created using the glLinkProgram method of linking.

Linking using glLinkProgram is supported by OpenGL 2.0 and up, but does not allow hot-swapping shaders without recompiling the program object like GLSLSeparableProgram can. Hence the name 'monolithic'.

## Constructor & Destructor Documentation

## ◆ GLSLMonolithicProgram()

Ogre::GLSLMonolithicProgram::GLSLMonolithicProgram | ( | GLSLShader * | vertexProgram,
|  | GLSLShader * | hullProgram,
|  | GLSLShader * | domainProgram,
|  | GLSLShader * | geometryProgram,
|  | GLSLShader * | fragmentProgram,
|  | GLSLShader * | computeProgram
| ) |  |

Constructor should only be used by GLSLMonolithicProgramManager.

## ◆ ~GLSLMonolithicProgram()

Ogre::GLSLMonolithicProgram::~GLSLMonolithicProgram | ( | void |  | ) |

## Member Function Documentation

## ◆ activate()

void Ogre::GLSLMonolithicProgram::activate | ( | void |  | ) |
| virtual

Makes a program object active by making sure it is linked and then putting it in use.

Implements Ogre::GLSLProgram.

## ◆ extractLayoutQualifiers()

virtual void Ogre::GLSLProgram::extractLayoutQualifiers | ( | void |  | ) |
| virtualinherited

Finds layout qualifiers in the shader source and sets attribute indices appropriately.

## ◆ getAttributeIndex()

virtual GLint Ogre::GLSLProgram::getAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| virtualinherited

Get the index of a non-standard attribute bound in the linked code.

Reimplemented in Ogre::GLSLSeparableProgram.

## ◆ getComputeShader()

GLSLShader* Ogre::GLSLProgram::getComputeShader | ( |  | ) | const
| inlineinherited

## ◆ getDomainShader()

GLSLShader* Ogre::GLSLProgram::getDomainShader | ( |  | ) | const
| inlineinherited

## ◆ getFragmentShader()

GLSLShader* Ogre::GLSLProgram::getFragmentShader | ( |  | ) | const
| inlineinherited

## ◆ getGeometryShader()

GLSLShader* Ogre::GLSLProgram::getGeometryShader | ( |  | ) | const
| inlineinherited

## ◆ getGLProgramHandle()

GLuint Ogre::GLSLProgram::getGLProgramHandle | ( | void |  | ) | const
| inlineinherited

Get the GL Handle for the program object.

## ◆ getHullShader()

GLSLShader* Ogre::GLSLProgram::getHullShader | ( |  | ) | const
| inlineinherited

## ◆ getVertexArrayObject()

GL3PlusOldVertexArrayObject* Ogre::GLSLProgram::getVertexArrayObject | ( |  | ) |
| inlineinherited

## ◆ getVertexShader()

GLSLShader* Ogre::GLSLProgram::getVertexShader | ( |  | ) | const
| inlineinherited

## ◆ isAttributeValid()

bool Ogre::GLSLProgram::isAttributeValid | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| inherited

Is a non-standard attribute bound in the linked code?

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inlineinherited

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLProgram::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inlineinherited

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ updatePassIterationUniforms()

void Ogre::GLSLMonolithicProgram::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| virtual

Updates program object uniforms using data from pass iteration GpuProgramParameters.

normally called by GLSLShader::bindMultiPassParameters() just before multi pass rendering occurs.

Implements Ogre::GLSLProgram.

## ◆ updateUniformBlocks()

void Ogre::GLSLMonolithicProgram::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniform blocks using data from GpuProgramParameters.

normally called by GLSLShader::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgram.

## ◆ updateUniforms()

void Ogre::GLSLMonolithicProgram::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniforms using data from GpuProgramParameters.

normally called by GLSLShader::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgram.

## Member Data Documentation

## ◆ mBaseInstanceLocation

GLint Ogre::GLSLProgram::mBaseInstanceLocation
| inherited

The documentation for this class was generated from the following file:

- OgreGLSLMonolithicProgram.h